VERSION 5.00
Begin VB.Form frmSetup 
   Caption         =   "ASCOM Meade Driver Setup"
   ClientHeight    =   6195
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6015
   LinkTopic       =   "Form1"
   ScaleHeight     =   6195
   ScaleWidth      =   6015
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox gPort 
      Height          =   315
      ItemData        =   "frmSetup.frx":0000
      Left            =   4680
      List            =   "frmSetup.frx":003B
      OLEDropMode     =   1  'Manual
      Style           =   2  'Dropdown List
      TabIndex        =   34
      Top             =   120
      Width           =   985
   End
   Begin VB.CommandButton cmdSetParkPosition 
      Caption         =   "&Set Park Position"
      Height          =   465
      Left            =   3465
      TabIndex        =   9
      ToolTipText     =   "Set park position to the original position (for scopes that support it)"
      Top             =   2400
      Width           =   990
   End
   Begin VB.TextBox txtApertureArea 
      Height          =   285
      Left            =   4695
      TabIndex        =   7
      Top             =   1485
      Width           =   975
   End
   Begin VB.CheckBox chkBeep 
      Caption         =   "Beep at slew completion"
      Height          =   375
      Left            =   315
      TabIndex        =   5
      ToolTipText     =   "On connect - set time to PC clock"
      Top             =   2475
      Width           =   2205
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "&Help"
      Height          =   345
      Left            =   2520
      TabIndex        =   17
      Top             =   5610
      Width           =   990
   End
   Begin VB.CommandButton cmdResetParkPosition 
      Caption         =   "&Reset Park Position"
      Height          =   465
      Left            =   4740
      TabIndex        =   10
      ToolTipText     =   "Set park position to the original position (for scopes that support it)"
      Top             =   2400
      Width           =   990
   End
   Begin VB.CheckBox chkAutoSetTime 
      Caption         =   "Auto Set Time   (LX200 ""classic"" only)"
      Height          =   375
      Left            =   300
      TabIndex        =   3
      ToolTipText     =   "On connect - set time to PC clock"
      Top             =   1440
      Width           =   1935
   End
   Begin VB.CheckBox chkAutoUnpark 
      Caption         =   "Auto      Unpark / Track"
      Height          =   375
      Left            =   315
      TabIndex        =   4
      ToolTipText     =   "On connect - Unpark and Track"
      Top             =   1935
      Width           =   1410
   End
   Begin VB.TextBox txtElevation 
      Height          =   285
      Left            =   2115
      TabIndex        =   2
      Top             =   690
      Width           =   975
   End
   Begin VB.TextBox txtFocalLength 
      Height          =   285
      Left            =   4680
      TabIndex        =   8
      Top             =   1920
      Width           =   975
   End
   Begin VB.TextBox txtAperture 
      Height          =   285
      Left            =   4680
      TabIndex        =   6
      Top             =   1080
      Width           =   975
   End
   Begin VB.PictureBox picASCOM 
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   840
      Left            =   120
      MouseIcon       =   "frmSetup.frx":00B6
      MousePointer    =   99  'Custom
      Picture         =   "frmSetup.frx":0208
      ScaleHeight     =   840
      ScaleWidth      =   720
      TabIndex        =   29
      Top             =   120
      Width           =   720
   End
   Begin VB.PictureBox picIcon 
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   480
      Left            =   120
      Picture         =   "frmSetup.frx":10CC
      ScaleHeight     =   480
      ScaleWidth      =   480
      TabIndex        =   27
      Top             =   4665
      Width           =   480
   End
   Begin VB.Frame Frame1 
      Caption         =   "Focuser Basics"
      Height          =   1500
      Left            =   135
      TabIndex        =   25
      Top             =   3060
      Width           =   2865
      Begin VB.TextBox txtMaxIncrement 
         Height          =   315
         Left            =   1560
         TabIndex        =   11
         Text            =   "Text1"
         Top             =   285
         Width           =   975
      End
      Begin VB.CheckBox chkFlip 
         Caption         =   "Reverse In/Out"
         Height          =   225
         Left            =   225
         TabIndex        =   12
         Top             =   705
         Width           =   1770
      End
      Begin VB.CheckBox chkDynamicBraking 
         Caption         =   "Dynamic Braking"
         Height          =   225
         Left            =   225
         TabIndex        =   13
         Top             =   1065
         Width           =   1815
      End
      Begin VB.Label Label2 
         Alignment       =   1  'Right Justify
         Caption         =   "Max Increment:"
         Height          =   225
         Left            =   165
         TabIndex        =   26
         Top             =   345
         Width           =   1155
      End
   End
   Begin VB.Frame lblBacklash 
      Caption         =   "Focuser Backlash Compensation"
      Height          =   1515
      Left            =   3105
      TabIndex        =   21
      Top             =   3060
      Width           =   2745
      Begin VB.Frame Frame2 
         Caption         =   "Final Dir."
         Height          =   975
         Left            =   150
         TabIndex        =   23
         Top             =   360
         Width           =   945
         Begin VB.OptionButton optFinalDirectionOut 
            Alignment       =   1  'Right Justify
            Caption         =   "Out"
            Height          =   255
            Left            =   135
            TabIndex        =   15
            Top             =   540
            Width           =   615
         End
         Begin VB.OptionButton optFinalDirectionIn 
            Alignment       =   1  'Right Justify
            Caption         =   "In"
            Height          =   255
            Left            =   135
            TabIndex        =   14
            Top             =   300
            Width           =   615
         End
      End
      Begin VB.TextBox txtBacklashSteps 
         Height          =   285
         Left            =   1680
         TabIndex        =   16
         Text            =   "0"
         Top             =   420
         Width           =   870
      End
      Begin VB.Label Label3 
         Alignment       =   2  'Center
         Caption         =   "Steps (ms)"
         Height          =   480
         Left            =   1125
         TabIndex        =   22
         Top             =   360
         Width           =   615
      End
   End
   Begin VB.CheckBox cb16in 
      Caption         =   "This is a 16"" LX200 ""classic"""
      Height          =   285
      Left            =   3360
      TabIndex        =   1
      Top             =   720
      Width           =   2430
   End
   Begin VB.ComboBox lbPort 
      Height          =   315
      ItemData        =   "frmSetup.frx":150E
      Left            =   1995
      List            =   "frmSetup.frx":1549
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   135
      Width           =   985
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   345
      Left            =   4860
      TabIndex        =   19
      Top             =   5610
      Width           =   990
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Height          =   345
      Left            =   3675
      TabIndex        =   18
      Top             =   5610
      Width           =   990
   End
   Begin VB.Label Label8 
      Caption         =   "909     Serial Port:"
      Height          =   495
      Left            =   3480
      TabIndex        =   35
      Top             =   120
      Width           =   855
   End
   Begin VB.Label Label7 
      Caption         =   "Aperture Area (m^2):"
      Height          =   225
      Left            =   3105
      TabIndex        =   33
      Top             =   1515
      Width           =   1545
   End
   Begin VB.Label Label6 
      Alignment       =   1  'Right Justify
      Caption         =   "Elevation (m):"
      Height          =   225
      Left            =   1035
      TabIndex        =   32
      Top             =   720
      Width           =   1035
   End
   Begin VB.Label Label5 
      Alignment       =   1  'Right Justify
      Caption         =   "Focal Length (m):"
      Height          =   225
      Left            =   3360
      TabIndex        =   31
      Top             =   1935
      Width           =   1275
   End
   Begin VB.Label Label4 
      Caption         =   "Aperture (m):"
      Height          =   225
      Left            =   3600
      TabIndex        =   30
      Top             =   1080
      Width           =   915
   End
   Begin VB.Label lblDriverNote 
      Caption         =   "<runtime driver note>"
      Height          =   870
      Left            =   765
      TabIndex        =   28
      Top             =   4680
      Width           =   5100
   End
   Begin VB.Label lblDriverInfo 
      Caption         =   "<runtime driver info>"
      Height          =   345
      Left            =   150
      TabIndex        =   24
      Top             =   5670
      Width           =   2370
   End
   Begin VB.Label Label1 
      Caption         =   "Scope Serial Port:"
      Height          =   495
      Left            =   1080
      TabIndex        =   20
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "frmSetup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------
' Copyright  2000-2002 SPACE.com Inc., New York, NY
'
' Permission is hereby granted to use this Software for any purpose
' including combining with commercial products, creating derivative
' works, and redistribution of source or binary code, without
' limitation or consideration. Any redistributed copies of this
' Software must include the above Copyright Notice.
'
' THIS SOFTWARE IS PROVIDED "AS IS". SPACE.COM, INC. MAKES NO
' WARRANTIES REGARDING THIS SOFTWARE, EXPRESS OR IMPLIED, AS TO ITS
' SUITABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
'---------------------------------------------------------------------
'   =============
'   FRMSETUP.FRM
'   =============
'
' Setup form for ASCOM Meade telescope driver
'
' Written:  22-Aug-00   Robert B. Denny <rdenny@dc3.com>
'
' Edits:
'
' When      Who     What
' --------- ---     --------------------------------------------------
' 22-Aug-00 rbd     Initial edit
' 21-Jan-01 rbd     New Helper.Profile object for registry stuff
'                   No more General subkey
' ??-Feb-02 ??      For combined Telescope & Focuser (Sheets & Weber)
' 18-Jun-02 rbd     Move focuser-related settings to the Focuser
'                   section of the profile data. We use our own
'                   Profile object now. Remove "Focuser " from
'                   registry value names for Focuser, now stored
'                   in the Focuser section so no longer need that
'                   additional labelling. Error handling cleanups.
'                   Fix backlash compensation final direction to
'                   be aware of the "Reverse In/Out" setting.
' 24-Jul-02 rbd     1.8.7 - Add "Classic" alert on selecting dynamic
'                   braking
' 26-jul-02 rbd     2.0.1 - for ASCOM 2, ASCOM logo and hot lonk
' 08-mar-03 jab     support for focal length and aperture
' 11-mar-03 jab     added elevation to dialog
' 28-sep-03 jab     added control of auto unpark
' 25-oct-o3 jab     setup dialog now works while connected
' 24-Nov-04 rbd     4.0.2 - COM Ports to 16
'---------------------------------------------------------------------

Option Explicit

Private Const SWP_NOSIZE            As Long = &H1
Private Const SWP_NOMOVE            As Long = &H2
Private Const SWP_NOZORDER          As Long = &H4
Private Const SWP_NOREDRAW          As Long = &H8
Private Const SWP_NOACTIVATE        As Long = &H10
Private Const SWP_FRAMECHANGED      As Long = &H20
Private Const SWP_SHOWWINDOW        As Long = &H40
Private Const SWP_HIDEWINDOW        As Long = &H80
Private Const SWP_NOCOPYBITS        As Long = &H100
Private Const SWP_NOOWNERZORDER     As Long = &H200
Private Const SWP_NOSENDCHANGING    As Long = &H400

Private Const SWP_DRAWFRAME         As Long = SWP_FRAMECHANGED
Private Const SWP_NOREPOSITION      As Long = SWP_NOOWNERZORDER

Private Const HWND_TOP              As Long = 0
Private Const HWND_BOTTOM           As Long = 1
Private Const HWND_TOPMOST          As Long = -1
Private Const HWND_NOTOPMOST        As Long = -2

Private Const SW_SHOWNORMAL         As Long = 1

Private oProfile As DriverHelper.Profile
Public m_DriverID As String

Private Declare Function SetWindowPos Lib "user32.dll" ( _
                ByVal hWnd As Long, _
                ByVal hWndInsertAfter As Long, _
                ByVal X As Long, _
                ByVal y As Long, _
                ByVal cx As Long, _
                ByVal cy As Long, _
                ByVal uFLags As Long) As Long

Private Declare Function ShellExecute Lib "shell32" Alias "ShellExecuteA" ( _
                ByVal hWnd As Long, _
                ByVal lpOperation As String, _
                ByVal lpFile As String, _
                ByVal lpParameters As String, _
                ByVal lpDirectory As String, _
                ByVal nShowCmd As Long) As Long

Private m_bInLoad As Boolean

' add settle time gui ??? (future feature)
' add park position for direct setting ??? (future feature)

Private Sub Form_Load()
    Dim Port As Long
    Dim buf As String
    
    m_bInLoad = True
    
    Set oProfile = New DriverHelper.Profile
    
    '
    ' Enable or disable fields that are dependent on connect state
    '
    lbPort.Enabled = Not (g_bTelescopeConnected Or g_bFocuserConnected)
    cb16in.Enabled = Not g_bTelescopeConnected
    txtMaxIncrement.Enabled = Not g_bFocuserConnected
    chkFlip.Enabled = Not g_bFocuserConnected
    chkDynamicBraking.Enabled = Not g_bFocuserConnected
    txtBacklashSteps.Enabled = Not g_bFocuserConnected
    optFinalDirectionIn.Enabled = Not g_bFocuserConnected
    optFinalDirectionOut.Enabled = Not g_bFocuserConnected
    
    If g_bTelescopeConnected And Not g_Scope Is Nothing Then
        If g_Scope.CanSetPark Then
            cmdSetParkPosition.Enabled = True
            cmdResetParkPosition.Enabled = True
        Else
            cmdSetParkPosition.Enabled = False
            cmdResetParkPosition.Enabled = False
        End If
    Else
        cmdSetParkPosition.Enabled = False
        cmdResetParkPosition.Enabled = False
    End If
    
    '
    ' First do the Telescope items
    '
    oProfile.DeviceType = "Telescope"
    buf = oProfile.GetValue(SCOPE_ID, "COM Port")
    If buf = "" Then buf = "1"              ' Default COM1
    Port = CInt(buf)
    lbPort.ListIndex = Port - 1             ' Select current port
'GC
    oProfile.DeviceType = "Telescope"
    buf = oProfile.GetValue(SCOPE_ID, "COM PortG")
    If buf = "" Then buf = "2"              ' Default COM1
    Port = CInt(buf)
    gPort.ListIndex = Port - 1             ' Select current port
'/GC
    buf = oProfile.GetValue(SCOPE_ID, "LX200 16 Inch")
    If buf = "" Then buf = "False"          ' Default not 16 in.
    If CBool(buf) Then
        cb16in.Value = 1                    ' Checked
    Else
        cb16in.Value = 0                    ' Unchecked
    End If
    
    On Error Resume Next
    buf = oProfile.GetValue(SCOPE_ID, "Aperture")
    txtAperture.Text = "User Input"
    If buf <> "" Then _
        txtAperture.Text = CStr(val(buf))
    
    buf = oProfile.GetValue(SCOPE_ID, "ApertureArea")
    txtApertureArea.Text = "User Input"
    If buf <> "" Then _
        txtApertureArea.Text = CStr(val(buf))
        
    buf = oProfile.GetValue(SCOPE_ID, "FocalLength")
    txtFocalLength.Text = "User Input"
    If buf <> "" Then _
        txtFocalLength.Text = CStr(val(buf))
    
    buf = oProfile.GetValue(SCOPE_ID, "SiteElevation")
    txtElevation.Text = "User Input"
    If buf <> "" Then _
        txtElevation.Text = CStr(val(buf))
    
    buf = oProfile.GetValue(SCOPE_ID, "Beep")
    If buf = "" Then buf = "1"
    chkBeep.Value = CLng(buf)
    
    buf = oProfile.GetValue(SCOPE_ID, "AutoUnpark")
    If buf = "" Then buf = "0"
    chkAutoUnpark.Value = CLng(buf)
    
    buf = oProfile.GetValue(SCOPE_ID, "AutoSetTime")
    If buf = "" Then buf = "0"
    chkAutoSetTime.Value = CLng(buf)
        
    '
    ' Now do the Focuser items
    '
    oProfile.DeviceType = "Focuser"
    buf = oProfile.GetValue(FOCUSER_ID, "Max Increment")
    If buf = "" Then buf = "7000"
    txtMaxIncrement = buf

    buf = oProfile.GetValue(FOCUSER_ID, "Flip Dir")
    If buf = "" Then buf = "0"
    chkFlip.Value = CLng(buf)
    
    buf = oProfile.GetValue(FOCUSER_ID, "Dynamic Braking")
    If buf = "" Then buf = "1"
    chkDynamicBraking.Value = CLng(buf)
    
    buf = oProfile.GetValue(FOCUSER_ID, "Backlash Steps")
    If buf = "" Then buf = "3000"
    txtBacklashSteps = buf
    
    buf = oProfile.GetValue(FOCUSER_ID, "Final Direction")
    If buf = "" Then buf = "Out"
    If buf = "In" Then
        optFinalDirectionIn.Value = True
    Else
        optFinalDirectionOut.Value = True
    End If
    
    On Error GoTo 0
    
    '
    ' Set up the version display
    '
    lblDriverInfo = "Version " & App.Major & "." & _
                             App.Minor & "." & App.Revision

    '
    ' Finally, display the appropriate note for the driver flavor.
    '
#If EXE_DRIVER = 1 Then
    lblDriverNote.Caption = _
        "This driver allows different programs to use the Telescope and Focuser at " & _
        "the same time. If you have problems connecting to the Telescope or Focuser, " & _
        "try the ""Meade LX200 and Autostar"" driver."
#Else
    lblDriverNote.Caption = _
        "This driver allows the Telescope and Focuser to be used from a single program " & _
        "only. If you want to use the Telescope and Focuser from two different programs, " & _
        "select the ""Meade Telescope and Focuser"" driver."
#End If
       
    '
    ' Assure window pops up on top of others.
    '
    SetWindowPos Me.hWnd, HWND_TOPMOST, 0, 0, 0, 0, (SWP_NOMOVE + SWP_NOSIZE)
    
    m_bInLoad = False
    
End Sub

Private Sub cmdOK_Click()
    Dim buf As String
    Dim MaxIncrement As Long
    Dim val As Double
    
    '
    ' First, do the Telescope-related items
    '
    oProfile.DeviceType = "Telescope"
    oProfile.WriteValue SCOPE_ID, "COM Port", Str(lbPort.ListIndex + 1)
    oProfile.WriteValue SCOPE_ID, "COM PortG", Str(gPort.ListIndex + 1)

    If cb16in.Value = 1 Then
        buf = "True"
    Else
        buf = "False"
    End If
    oProfile.WriteValue SCOPE_ID, "LX200 16 Inch", buf
    
    ' don't force user to fill out field, do check for valid entry
    If txtAperture.Text = "User Input" Then
        oProfile.WriteValue SCOPE_ID, "Aperture", ""
    Else
        On Error Resume Next
            val = 0
            val = CDbl(txtAperture.Text)
        On Error GoTo 0
        If val > 0 Then
            oProfile.WriteValue SCOPE_ID, "Aperture", Str(val)
        Else
            MsgBox "You must enter a positive number for Aperture", _
                vbExclamation
            txtAperture.SetFocus                    ' Put cursor in this box
            Exit Sub
        End If
    End If
    
    ' don't force user to fill out field, do check for valid entry
    If txtApertureArea.Text = "User Input" Then
        oProfile.WriteValue SCOPE_ID, "ApertureArea", ""
    Else
        On Error Resume Next
            val = 0
            val = CDbl(txtApertureArea.Text)
        On Error GoTo 0
        If val > 0 Then
            oProfile.WriteValue SCOPE_ID, "ApertureArea", Str(val)
        Else
            MsgBox "You must enter a positive number for Aperture Area", _
                vbExclamation
            txtApertureArea.SetFocus                ' Put cursor in this box
            Exit Sub
        End If
    End If
    
    ' don't force user to fill out field, do check fo valid entry
    If txtFocalLength.Text = "User Input" Then
        oProfile.WriteValue SCOPE_ID, "FocalLength", ""
    Else
        On Error Resume Next
            val = 0
            val = CDbl(txtFocalLength.Text)
        On Error GoTo 0
        If val > 0 Then
            oProfile.WriteValue SCOPE_ID, "FocalLength", Str(val)
        Else
            MsgBox "You must enter a positive number for Focal Length", _
                vbExclamation
            txtFocalLength.SetFocus                  ' Put cursor in this box
            Exit Sub
        End If
    End If
    
    ' don't force user to fill out field, do check fo valid entry
    If txtElevation.Text = "User Input" Then
        oProfile.WriteValue SCOPE_ID, "SiteElevation", ""
    Else
        On Error Resume Next
            val = -1000000    ' illigal number to catch failed convertion
            val = CDbl(txtElevation.Text)
        On Error GoTo 0
        
        If val = -1000000 Then
            MsgBox "You must enter a number for Elevation", _
                vbExclamation
            txtElevation.SetFocus                  ' Put cursor in this box
            Exit Sub
        Else
            oProfile.WriteValue SCOPE_ID, "SiteElevation", Str(val)
        End If
    End If

    oProfile.WriteValue SCOPE_ID, "Beep", CStr(chkBeep.Value)
    oProfile.WriteValue SCOPE_ID, "AutoUnpark", CStr(chkAutoUnpark.Value)
    oProfile.WriteValue SCOPE_ID, "AutoSetTime", CStr(chkAutoSetTime.Value)
    
    '
    ' Then do the Focuser-related items
    '
    oProfile.DeviceType = "Focuser"
    '
    ' Save the "number" in the max increment check box, blindly.
    ' If this value is invalid then we default to 100 ms.
    '
    On Error Resume Next
    MaxIncrement = (-1)
    MaxIncrement = CLng(txtMaxIncrement)
    On Error GoTo 0
    If MaxIncrement > 0 Then
        oProfile.WriteValue FOCUSER_ID, "Max Increment", CStr(txtMaxIncrement)
    Else
        MsgBox "You must enter a non-negative number for the maximum number of " & _
                "milliseconds to actuate the focuser.", vbExclamation
        txtMaxIncrement.SetFocus                    ' Put cursor in this box
        Exit Sub
    End If
    '
    ' Invalid entries in txtBacklashSteps are eliminated with
    ' Sub txtBacklashSteps_KeyPress
    '
    oProfile.WriteValue FOCUSER_ID, "Backlash Steps", CStr(txtBacklashSteps)
    If optFinalDirectionOut.Value = True Then
        oProfile.WriteValue FOCUSER_ID, "Final Direction", "Out"
    Else
        oProfile.WriteValue FOCUSER_ID, "Final Direction", "In"
    End If
    oProfile.WriteValue FOCUSER_ID, "Flip Dir", CStr(chkFlip.Value)
    oProfile.WriteValue FOCUSER_ID, "Dynamic Braking", CStr(chkDynamicBraking.Value)
    
    Me.Hide
    
End Sub

Private Sub cmdCancel_Click()

    Me.Hide
    
End Sub

Private Sub chkDynamicBraking_Click()

    If Not m_bInLoad And (chkDynamicBraking.Value = 1) Then _
        MsgBox "Dynamic braking works only on the LX200 Classic.", _
            (vbOKOnly + vbInformation + vbMsgBoxSetForeground), _
            App.Title
End Sub

Private Sub txtBacklashSteps_KeyPress(KeyAscii As Integer)

    Select Case KeyAscii
        Case vbKeyBack              ' Allow these control chars
        Case vbKeyReturn
        Case vbKeyEnd
        Case 48 To 57               ' Allow 0 - 9
        Case Else                   ' Cancel anything else
            KeyAscii = 0
    End Select
    
End Sub

Private Sub picASCOM_Click()
    Dim z As Long

    z = ShellExecute(0, "Open", "http://ASCOM-Standards.org/", 0, 0, SW_SHOWNORMAL)
    If (z > 0) And (z <= 32) Then
        MsgBox _
            "It doesn't appear that you have a web browser installed " & _
            "on your system.", (vbOKOnly + vbExclamation + vbMsgBoxSetForeground), ERR_SOURCE
        Exit Sub
    End If
End Sub

Private Sub cmdSetParkPosition_Click()

    If Not g_Scope Is Nothing Then
        If Not g_Scope.CanSetPark Then
            MsgBox "SetPark not supported with this telescope.", _
                (vbOKOnly + vbExclamation + vbMsgBoxSetForeground), ERR_SOURCE
            Exit Sub
        End If
        
        On Error GoTo SetParkError
            g_Scope.SetPark
        On Error GoTo 0
    End If
    
    Exit Sub
    
SetParkError:
    MsgBox "Set Park error.  Likely bad park position.", _
        (vbOKOnly + vbExclamation + vbMsgBoxSetForeground), ERR_SOURCE

    Resume Next
    
End Sub

Private Sub cmdResetParkPosition_Click()

    oProfile.DeviceType = "Telescope"
    
    ' This doesn't clear any current parked state
    ' I think this is best since not all scopes can do so
    On Error Resume Next
    oProfile.WriteValue SCOPE_ID, "ParkAlt", ""
    oProfile.WriteValue SCOPE_ID, "ParkAz", ""
    On Error GoTo 0
    
End Sub

Private Sub cmdHelp_Click()
    Dim z As Long

    z = ShellExecute(0, "Open", App.Path & "/MeadeHelp.htm", 0, 0, SW_SHOWNORMAL)
    If (z > 0) And (z <= 32) Then
        MsgBox _
            "It doesn't appear that you have a web browser installed " & _
            "on your system.", (vbOKOnly + vbExclamation + vbMsgBoxSetForeground), ERR_SOURCE
        Exit Sub
    End If

End Sub

